#version 430
layout (location = 0) in vec3 position;
layout(location = 1) in vec3 normal;
layout(location = 2) in vec2 uv;

uniform mat4 modelMatrix;
uniform mat4 viewProjMatrix;
uniform mat3 normalMatrix;

uniform float time;

const float PI = 3.14159265359;

out VertexData {
	vec3 position_world;
	vec3 normal_world;
	vec2 uv;
} vert;

void main() {
	vec3 newPos = position + vec3(0.0f,sin((time+position.x)*0.05f)*4.0f,0.0f);
	vert.uv = uv;
	vec3 newNormal = vec3(1.0f-abs(sin((time+position.x)*0.05f)),1.0f,0.0f);
	vert.normal_world = normalMatrix * normalize(newNormal);
	vert.position_world = vec4(modelMatrix * vec4(newPos, 1.0)).xyz;
	gl_Position = viewProjMatrix * modelMatrix * vec4(newPos, 1.0);
}